package com.gyee.alarm.model.auto;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.util.List;

/**
 * <p>
 * 设备预警报告
 * </p>
 *
 * @author shilin
 * @since 2023-09-05
 */
@Data
@EqualsAndHashCode(callSuper = true)
public class ProEconEarlyReportWt extends Model {

    private static final long serialVersionUID = 1L;

    /**
     * 编号
     */
    @TableId(value = "ID",type = IdType.INPUT)
    private String id;

    /**
     * 风机id
     */
    private String windturbineId;

    /**
     * 风机编号或名称
     */
    private String windturbineCode;

    /**
     * 风机型号
     */
    private String modelId;

    /**
     * 对比的风机报告编号
     */
    private String compareId;

    /**
     * 结论
     */
    private String conclusion;

    /**
     * earlyreport表主键
     */
    private String reportId;

    /**
     * 是否比较过
     */
    private Boolean compared;

    /**
     * 核实的
     */
    private Boolean verified;

    @TableField(exist = false)
    private ProEconEarlyReport earlyReport;

    @TableField(exist = false)
    private List<ProEconEarlyReportAlarm> alarmInfoList;

    @TableField(exist = false)
    private List<ProEconEarlyReportAlarm> compareAlarmInfoList;
}
